<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfArrayOfJPSOAP_HotelRatePlanSpecialNoteText
 * ArrayType
 * @subpackage Arrays
 */
class ArrayOfArrayOfJPSOAP_HotelRatePlanSpecialNoteText extends AbstractStructArrayBase
{
    /**
     * The Note
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \ArrayType\ArrayOfJPSOAP_HotelRatePlanSpecialNoteText[]
     */
    public $Note;
    /**
     * Constructor method for ArrayOfArrayOfJPSOAP_HotelRatePlanSpecialNoteText
     * @uses ArrayOfArrayOfJPSOAP_HotelRatePlanSpecialNoteText::setNote()
     * @param \ArrayType\ArrayOfJPSOAP_HotelRatePlanSpecialNoteText[] $note
     */
    public function __construct(array $note = array())
    {
        $this
            ->setNote($note);
    }
    /**
     * Get Note value
     * @return \ArrayType\ArrayOfJPSOAP_HotelRatePlanSpecialNoteText[]|null
     */
    public function getNote()
    {
        return $this->Note;
    }
    /**
     * Set Note value
     * @throws \InvalidArgumentException
     * @param \ArrayType\ArrayOfJPSOAP_HotelRatePlanSpecialNoteText[] $note
     * @return \ArrayType\ArrayOfArrayOfJPSOAP_HotelRatePlanSpecialNoteText
     */
    public function setNote(array $note = array())
    {
        foreach ($note as $arrayOfArrayOfJPSOAP_HotelRatePlanSpecialNoteTextNoteItem) {
            // validation for constraint: itemType
            if (!$arrayOfArrayOfJPSOAP_HotelRatePlanSpecialNoteTextNoteItem instanceof \ArrayType\ArrayOfJPSOAP_HotelRatePlanSpecialNoteText) {
                throw new \InvalidArgumentException(sprintf('The Note property can only contain items of \ArrayType\ArrayOfJPSOAP_HotelRatePlanSpecialNoteText, "%s" given', is_object($arrayOfArrayOfJPSOAP_HotelRatePlanSpecialNoteTextNoteItem) ? get_class($arrayOfArrayOfJPSOAP_HotelRatePlanSpecialNoteTextNoteItem) : gettype($arrayOfArrayOfJPSOAP_HotelRatePlanSpecialNoteTextNoteItem)), __LINE__);
            }
        }
        $this->Note = $note;
        return $this;
    }
    /**
     * Add item to Note value
     * @throws \InvalidArgumentException
     * @param \ArrayType\ArrayOfJPSOAP_HotelRatePlanSpecialNoteText $item
     * @return \ArrayType\ArrayOfArrayOfJPSOAP_HotelRatePlanSpecialNoteText
     */
    public function addToNote(\ArrayType\ArrayOfJPSOAP_HotelRatePlanSpecialNoteText $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \ArrayType\ArrayOfJPSOAP_HotelRatePlanSpecialNoteText) {
            throw new \InvalidArgumentException(sprintf('The Note property can only contain items of \ArrayType\ArrayOfJPSOAP_HotelRatePlanSpecialNoteText, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->Note[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \ArrayType\ArrayOfJPSOAP_HotelRatePlanSpecialNoteText|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \ArrayType\ArrayOfJPSOAP_HotelRatePlanSpecialNoteText|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \ArrayType\ArrayOfJPSOAP_HotelRatePlanSpecialNoteText|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \ArrayType\ArrayOfJPSOAP_HotelRatePlanSpecialNoteText|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \ArrayType\ArrayOfJPSOAP_HotelRatePlanSpecialNoteText|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string Note
     */
    public function getAttributeName()
    {
        return 'Note';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfArrayOfJPSOAP_HotelRatePlanSpecialNoteText
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
